;=======================================
; EGP01_ASM.s 
; EGP01pAZu Tu[`
;=======================================
; Rev 00 : 2010.11.24 Konya (New Release)
;======================================= 
	.include "p33FJ128GP804.inc" 


;---------------------------------------------
;Configuration
;---------------------------------------------
config __FBS, RBS_NO_RAM & BSS_NO_FLASH & BWRP_WRPROTECT_OFF
config __FSS, RSS_NO_RAM & SSS_NO_FLASH & SWRP_WRPROTECT_OFF
config __FGS, GSS_OFF & GCP_OFF & GWRP_OFF
config __FOSCSEL,FNOSC_FRCPLL & IESO_OFF
config __FOSC, FCKSM_CSDCMD & IOL1WAY_OFF & OSCIOFNC_ON & POSCMD_NONE
config __FWDT, FWDTEN_OFF & WINDIS_OFF
config __FPOR, ALTI2C_OFF & FPWRT_PWR1
config __FICD, JTAGEN_OFF & ICS_PGD1
;---------------------------------------------
;O[oϐ&֐錾
;---------------------------------------------
;ϐ
    .global __reset           ;The label for the first line of code. 
    .global __OC1Interrupt    ;Declare OC1 ISR name global
    .global __OC2Interrupt    ;Declare OC2 ISR name global
    .global __ADC1Interrupt   ;Declare AD1 ISR name global
    .global __DAC1Interrupt   ;Declare DAC1 ISR name global

	.global	_SclY			;wiXN[pJE^(YW)
	.global	_Snd0_ST		;TEh0pXe[^X		
	.global	_Snd1_ST		;TEh1pXe[^X	
	.global	_Snd2_ST		;TEh2pXe[^X	
	.global	_GTS0			;GameTopScore0
	.global	_GTS1			;GameTopScore1
	.global	_GTS2			;GameTopScore2
	.global	_GTS3			;GameTopScore3
	.global	_GTS4			;GameTopScore4
	.global	_GTS5			;GameTopScore5
	.global	_GTS6			;GameTopScore6
	.global	_GTS7			;GameTopScore7
;֐
	.global	_Wait_ms		; EFCg msP(FWait@ߒlFȂ)
	.global	_PicIni
	.global	_LcdIni
	.global	_TitlePig
	.global	_LCD_CLS
	.global _VR_PalSet		; PICVRAM@pbgݒ(F@Ȃ ߒlFȂ)
	.global	_VR_LCDDraw		; PICVRAM LCDꊇ](F@Ȃ ߒlFȂ)
	.global	_VR_BSDraw		; PICVRAMւ̔wi`(F@Ȃ ߒlFȂ)
	.global _VR_ChrDraw		; PICVRAMւ̃LN^`(F`X,Y,p^[ԍ ߒlFȂ)
	.global _VR_ChrDrawC	; FwpPICVRAMւ̃LN^`(F`X,Y,p^[ԍ,F ߒlFȂ)		
	.global _VR_ChrSclDraw	; PICVRAMւ̃LN^`(F`X,Y,p^[ԍ ߒlFȂ)		
	.global _VR_ChrDraw2C	; 2Ff[^@PICVRAMւ̃LN^`(F`X,Y,p^[ԍ,F ߒlFȂ)
	.global _VR_MojiDraw	; 2Ff[^@PICVRAMւ̃LN^`(F`X,Y,p^[ԍ,F,Font ߒlFȂ)
	.global _VR_AllClr		; PICVRAMI[NA(FNApbgԍ ߂lFȂ)
	.global	_SndSetPCM0		;PWMɂPCMo0
	.global	_SndSetPCM1		;PWMɂPCMo1
	.global	_SndSet0		;PWM_CNgo
	.global _VR_NumDrw		; \
	.global _GTSWr			;gbvXRÃtbV
	.global _GTSRd			;gbvXRÃtbVǏo
;---------------------------------------------
;Œlݒ
;---------------------------------------------
	;̓{^ݒ
		.equ JRC ,0x04	;Right Center RC4
		.equ JRU ,0x04	;Right UP     RB4 
		.equ JRR ,0x05	;Right Right  RC5 
		.equ JRD ,0x04	;Right Down   RA4
		.equ JRL ,0x03	;Right Left   RC3

		.equ JLC ,0x03	;Left Center RB3 
		.equ JLU ,0x03	;Left UP     RB0
		.equ JLR ,0x02	;Left Right  RB2 
		.equ JLD ,0x02	;Left Down   RB1
		.equ JLL ,0x00	;Left Left   RC0 
	;PICLCD@VRAM@擪AhX
		.equ LVRAM, 0x2800		;LCD VRAM 擪AhX
;---------------------------------------------
;memory space
;---------------------------------------------
;Near data memory
	.section .usrram, bss, near
STUCK:		.space 0x100
Palet:		.space 16		;pbg0-15
Pal16:		.space 32		;LCD\p16Fpbg(12bit/1F)

H2D_1:			.space 1		;1610iϊ(1̈)
H2D_10:			.space 1		;1610iϊ(10̈)
H2D_100:		.space 1		;1610iϊ(100̈)
H2D_1000:		.space 1		;1610iϊ(1000̈)
H2D_10000:		.space 1		;1610iϊ(10000̈)
H2D_Dmy:		.space 1		;_~[
;TEhpXe[^XWX^
;+0 TEhf[^CfbNXAhX
;+2 TEhf[^ŏICfbNXAhX
;+4 TEhf[^i[AhX擪(tblpage)
;+6 TEhf[^i[AhX擪(tbloffset)

_Snd_St:		.space 2		;Snd0-2̓ bit0=1:Snd1쒆 bit1=1:Snd2쒆
_Snd0_ST:		.space 8		;TEh0pXe[^X
_Snd1_ST:		.space 8		;TEh1pXe[^X
_Snd2_ST:		.space 8		;TEh2pXe[^X

;PICLCD@VRAMpWX^
_SclY:			.space 2		;wiXN[pJE^
DrawY:			.space 2		;wi`pYWJE^
_GTS0:			.space 2		;
_GTS1:			.space 2		;
_GTS2:			.space 2		;
_GTS3:			.space 2		;
_GTS4:			.space 2		;
_GTS5:			.space 2		;
_GTS6:			.space 2		;
_GTS7:			.space 2		;

SndSel:			.space 2		;0:PWM_CNgó@1:PWMɂPCMo

;***************************************************************
;֘A
;***************************************************************
	.text					;Start of Code section

;-------------------------------------
;PIC(NbNA|[gAW[)ݒ
;-------------------------------------
;F@Ȃ
;ߒlF@Ȃ
_PicIni:
	;CLKݒ
		MOV		#0x0000,w0		;
		MOV		w0, CLKDIV		;
;		MOV		#10, w0			;  Fosc =7.37MHz x 8/2x2 =14.74MHz
;		MOV		w0, PLLFBD		;  Fcy = 14.7/2 = 7.37MIPS

		MOV		#45, w0			;  Fosc =7.37MHz x 43/2x2 =79.23MHz
		MOV		w0, PLLFBD		;  Fcy = 79.23/2 = 39.62MIPS
	;PORTݒ

		MOV		#0x01FF,w0		;AD1PCFGL
		MOV		w0, AD1PCFGL	;All pin=Digital I/O

		MOV		#0x0010,w0		;TRISA
		MOV		w0, TRISA		;RA4 =input, Other pin=output


		MOV		#0x001F,w0		;TRISB
		MOV		w0, TRISB		;RB0,1,2,3,4=input, Other pin=output

		MOV		#0x0039,w0		;TRISC
		MOV		w0, TRISC		;RC0,3,4,5=input, Other pin=output

		MOV		#0x01F3,w0		;CNPU1
		MOV		w0, CNPU1		;CN0,1,4,5,6,7,8 Pull UP		
								
		MOV		#0x1600,w0		;CNPU2
		MOV		w0, CNPU2		;CN25,26,28 Pull UP

		BSET	LATB, #14		;~WR
		BSET	LATB, #15		;~C/D
		BCLR	LATB, #5		;D7
		BCLR	LATB, #6		;D6
		BCLR	LATB, #7		;D5
		BCLR	LATB, #8		;D4
		BCLR	LATB, #9		;D3
		BCLR	LATB, #10	    ;D2
		BCLR	LATB, #11   	;D1
		BCLR	LATB, #12   	;D0
		BCLR	LATC, #5		;LCD BackLight@OFF

	;PMPݒ
		MOV		#0b1010001000100000, w0
		MOV		w0, PMCON
		MOV		#0b0000001000000000, w0
		MOV		w0, PMMODE
		MOV		#0b0100000000000010, w0
		MOV		w0, PMAEN
		MOV		#0b0000000000000000, w0
		MOV		w0, PMADDR


	;o̓RyA(TEho)ݒ
		MOV		#0x1200,w0		;P#25  RP17 = Output Compare1
		MOV		w0, RPOR8		;
	;o̓RyA荞
		MOV		#0x0000,w0
		MOV		w0, OC1CON			;o̓RyA
		MOV		#0x0005,w0
		MOV		w0, OC1CON			;fArv[h-Ao	

		BCLR	IFS0, #OC1IF		;荞݃tONA
		BSET	IEC0, #OC1IE		;荞݃Cl[u
	;o̓RyAp^C}[Qݒ
		MOV		#0x00010, w0		;JEgAbvNbN = Fcy/8
		MOV		w0, T2CON

		RETURN




;-----------------------
;@LCDR}h]}N
;-----------------------
.macro mLCDCMD cmd

		MOV		\cmd, w1
		CALL	LCD_SendCmd
.endm

;-----------------------
;@LCDf[^]}N
;-----------------------
.macro mLCDDAT data

		MOV		\data, w1
		CALL	LCD_SendDat
.endm
;-------------------------------------
;LCD (ZY-FGD1442701V1)
;-------------------------------------
;F@Ȃ
;ߒlF@Ȃ
_LcdIni:
;LCD CMD
	.equ SWRESET,	0x01 
	.equ RDDID,		0x04 
	.equ RDDST,    	0x09 
	.equ RDDPM,    	0x0a 
	.equ RDDMADCTL, 0x0b 
	.equ RDDCOLMOD, 0x0c 
	.equ RDDIM,    	0x0d 
	.equ RDDSM, 	0x0e 
	.equ SLPIN,		0x10   
	.equ SLPOUT,  	0x11
	.equ PTLON,	    0x12 
	.equ NORON,	    0x13 
	.equ INVOFF,    0x20 
	.equ INVON,	    0x21 
	.equ GAMSET,    0x26 
	.equ DISPOFF,   0x28 
	.equ DISPON,    0x29 
	.equ CASET,    	0x2a 
	.equ RASET,    	0x2b 
	.equ RAMWR,    	0x2c 
	.equ RAMRD,    	0x2e 
	.equ PTLAR,    	0x30
	.equ TEOFF,    	0x34 
	.equ TEON,    	0x35 
	.equ MADCTL,   	0x36
	.equ IDMOFF,   	0x38 
	.equ IDMON,    	0x39 
	.equ COLMOD,   	0x3a
	.equ RDID1,    	0xda 
	.equ RDID2,    	0xdb 
	.equ RDID3,    	0xdc

	.equ FRMCTR1,	0xB1    	
	.equ FRMCTR2,	0xB2 
	.equ FRMCTR3,	0xB3 
	.equ INVCTR,	0xB4 
	.equ DISSET5,	0xB6 
	.equ PWCTR1,	0xc0 
	.equ PWCTR2,	0xc1 
	.equ PWCTR3,	0xc2 
	.equ PWCTR4,	0xc3 
	.equ PWCTR5,	0xc4 
	.equ VMCTR1,	0xc5 
	.equ VMOFCTR,	0xc7 
	.equ WRID2,		0xd1 
	.equ WRID3,		0xd2 
	.equ PWCTR6,	0xfc 
	.equ NVCTR1,	0xd9 
	.equ NVCTR2,	0xde 
	.equ NVCTR3,	0xdf 
	.equ GAMCTRP1,	0xe0 
	.equ GAMCTRN1,	0xe1 
	.equ EXTCTRL,	0xf0 
	.equ VCOM4L,	0xff 

		BSET	LATA, #7		;RD=1
		BSET	LATB, #14		;~WR
		BSET	LATB, #15		;~C/D

		BSET	LATB, #13		;~RST = 1
		MOV		#100, w0		;wait 100ms
		CALL	_Wait_ms


		BCLR	LATB, #13		;~RST = 0
		MOV		#100, w0		;wait 100ms
		CALL	_Wait_ms


		BSET	LATB, #13		;~RST = 1
		MOV		#120, w0		;wait 120ms
		CALL	_Wait_ms

	;SWRESET
		mLCDCMD	#SWRESET
		MOV		#50, w0		;wait 50ms
		CALL	_Wait_ms

	;Sleep Out
		mLCDCMD	#SLPOUT
		MOV		#200, w0		;wait 200ms
		CALL	_Wait_ms

	;VCOM4L
		mLCDCMD	#VCOM4L
		mLCDDAT	#0x40		
		mLCDDAT	#0x03
		mLCDDAT	#0x1a

	;NVCTR1
		mLCDCMD	#NVCTR1
		mLCDDAT	#0x60
	;VMOFCTR
		mLCDCMD	#VMOFCTR
		mLCDDAT	#0x90
		MOV		#200, w0		;wait 200ms
		CALL	_Wait_ms
	;FRMCTR1
		mLCDCMD	#FRMCTR1
		mLCDDAT	#0x04	
		mLCDDAT	#0x25
		mLCDDAT	#0x18
	;FRMCTR2
		mLCDCMD	#FRMCTR2
		mLCDDAT	#0x04	
		mLCDDAT	#0x25
		mLCDDAT	#0x18
	;FRMCTR3
		mLCDCMD	#FRMCTR3
		mLCDDAT	#0x04	
		mLCDDAT	#0x25
		mLCDDAT	#0x18
		mLCDDAT	#0x04	
		mLCDDAT	#0x25
		mLCDDAT	#0x18
	;INVCTR
		mLCDCMD	#INVCTR
		mLCDDAT	#0x03

	;DISSET5
		mLCDCMD	#DISSET5
		mLCDDAT	#0x15	
		mLCDDAT	#0x02
	;PWCTR1
		mLCDCMD	#PWCTR1
		mLCDDAT	#0x02	
		mLCDDAT	#0x70
	;PWCTR2
		mLCDCMD	#PWCTR2
		mLCDDAT	#0x07	
	;PWCTR3
		mLCDCMD	#PWCTR3
		mLCDDAT	#0x01	
		mLCDDAT	#0x01
	;PWCTR4
		mLCDCMD	#PWCTR4
		mLCDDAT	#0x02	
		mLCDDAT	#0x07
	;PWCTR5
		mLCDCMD	#PWCTR5
		mLCDDAT	#0x02	
		mLCDDAT	#0x04
	;PWCTR6
		mLCDCMD	#PWCTR6
		mLCDDAT	#0x11	
		mLCDDAT	#0x17
	;VMCTR1
		mLCDCMD	#VMCTR1
		mLCDDAT	#0x3c	
		mLCDDAT	#0x4f
	;MADCTL
		mLCDCMD	#MADCTL
		mLCDDAT	#0xc8
	;COLMOD
		mLCDCMD	#COLMOD
		mLCDDAT	#0x03	;12bit/pixel
	;GAMCTRP1
		mLCDCMD	#GAMCTRP1
		mLCDDAT	#0x06
		mLCDDAT	#0x0e
		mLCDDAT	#0x05
		mLCDDAT	#0x20
		mLCDDAT	#0x27
		mLCDDAT	#0x23
		mLCDDAT	#0x1c
		mLCDDAT	#0x21
		mLCDDAT	#0x20
		mLCDDAT	#0x1c
		mLCDDAT	#0x26
		mLCDDAT	#0x2f
		mLCDDAT	#0x00
		mLCDDAT	#0x03
		mLCDDAT	#0x00
		mLCDDAT	#0x24
	;GAMCTRN1
		mLCDCMD	#GAMCTRN1
		mLCDDAT	#0x06
		mLCDDAT	#0x10
		mLCDDAT	#0x05
		mLCDDAT	#0x21
		mLCDDAT	#0x27
		mLCDDAT	#0x22
		mLCDDAT	#0x1c
		mLCDDAT	#0x21
		mLCDDAT	#0x1f
		mLCDDAT	#0x1d
		mLCDDAT	#0x27
		mLCDDAT	#0x2f
		mLCDDAT	#0x05
		mLCDDAT	#0x03
		mLCDDAT	#0x00
		mLCDDAT	#0x3f


;LCD VRAM ALL CLR
	;CASET
		mLCDCMD	#CASET
		mLCDDAT #0				;Start
		mLCDDAT #2
		mLCDDAT #0				;END
		mLCDDAT #129

	;RASET
		mLCDCMD	#RASET
		mLCDDAT #0				;Start
		mLCDDAT #1
		mLCDDAT #0				;END
		mLCDDAT #128



	;RAMWR
		mLCDCMD	#RAMWR

;		MOV		#8192, w10
		MOV		#32768, w10
SCR_Clr:
		mLCDDAT #0x00			
		mLCDDAT #0x00
;		mLCDDAT #0x00
		DEC		w10, w10
		BRA		NZ, SCR_Clr


	;DISPON
		mLCDCMD	#DISPON
		MOV		#200, w0		;wait 200ms
		CALL	_Wait_ms

		RETURN




;***************************************************************
;zVRAM֘A
;***************************************************************
;-------------------------------------------
;PICVRAM@pbgݒ
;-------------------------------------------
;F@Ȃ
;F@Ȃ

_VR_PalSet:
	;16F[hpbgǂݍ
		MOV		#tblpage(CmnPal),w8		;w8=ʃpbgi[AhX
		MOV		w8, _TBLPAG				;
		MOV		#tbloffset(CmnPal),w8	;

		MOV		#Pal16, w2
		TBLRDL [w8++], w1	;pbg0ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg1ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg2ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg3ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg4ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg5ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg6ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg7ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg8ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg9ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg10ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg11ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg12ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg13ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg14ǂݍ
		MOV		w1,[w2++]
		TBLRDL [w8++], w1	;pbg15ǂݍ
		MOV		w1,[w2]


;-------------------------------------------
;@PICVRAMLCDꊇ]
;-------------------------------------------
;F@Ȃ
;ߒlF@Ȃ

_VR_LCDDraw:
	;CASET
		mLCDCMD	#CASET
		mLCDDAT #0				;Start
		mLCDDAT #2
		mLCDDAT #0				;END
		mLCDDAT #129

	;RASET
		mLCDCMD	#RASET
		mLCDDAT #0				;Start
		mLCDDAT #4
		mLCDDAT #0				;END
		mLCDDAT #131

	;RAMWR
		mLCDCMD	#RAMWR

	;LCD Draw
		MOV		#8192, w4			;f[^=128*128*0.5byte =8192
		MOV		#LVRAM, w12			;PICLCD VRAM擪AhX	
		MOV		#Pal16, w10			
		MOV		#0x000f, w9	

LDraw_Lp:
		CLR		w0
		MOV.b	[w12++], w0			;Read LCDVRam Datai2dot)
		AND		w0, w9, w1			;hbg̐FNo𔲂oA
		SL		w1, #1, w1			;16FpbgRGBf[^擾
		ADD		w10, w1, w1
		MOV		[w1], w2			;W2=DotL 0000RRRRGGGGBBBB
		LSR		w2, #4, w1
		CALL	LCD_SendDat			;Send DotL RRRRGGGG
		LSR		w0, #4, w0			;Ehbg̐FNo𔲂oA
		SL		w0, #1, w0			;16FpbgRGBf[^擾

		ADD		w10, w0, w0			
		MOV		[w0], w3			;W1=DotR 0000RRRRGGGGBBBB
		LSR		w3, #8, w0			;hbgBƉEf[^Rf[^
		SL		w2, #4, w1			;
		IOR		w1, w0, w1
		CALL	LCD_SendDat			;Send DotL BBBB DotR RRRR
		MOV		w3,  w1
		CALL	LCD_SendDat			;Send DotR GGGGBBBB

		DEC		w4, w4
		BRA		NZ, LDraw_Lp

		RETURN

;-------------------------------------------
;@PICVRAMւ̔wi`
;-------------------------------------------
;MapDataɏ]AMapChipPICLCD VRAMɔzuB
;wi16F[h,8x8hbg̃}bv`bv

_VR_BSDraw:

		MOV		#tblpage(_MapChip0),w8	;w8=Map Chip Data Adr
		MOV		w8, _TBLPAG				;
		MOV		#tbloffset(_MapChip0),w8	;		
		ADD		#2, w8					;MapChipData̐擪ɂ
										; TCY2byte邽߃AhX+2 
  ;(1)ʏ[
  ;   XN[ʒuɂĂMapChip̏㕔͂ݏoB̂߁ANbsO{
	;MAPAhXZo
		MOV		#tblpage(Map0),w9		;w9=Map Data offset Adr
		MOV		w9, _TBLPAG				;
		MOV		#tbloffset(Map0),w9		;
		MOV		_SclY, w0				;w9=wiMap offset Adr
		MOV		w0, DrawY				;@  +@SclY / 8 *16
		LSR		w0, #3, w0				;
 		SL		w0, #4, w0				;
		ADD		w9, w0, w9				;
	;NbsÔ߁A͂ݏoȂSizeYZo
		MOV		#0x0007, w0				;w10 = SclY[2:0]
		MOV		_SclY, w4
		AND		w4, w0, w4
		MOV		#8, w0					;SizeY(w5)=8-SclY[2:0]
		SUB		w0, w4, w5

		MOV		#LVRAM, w11				;W11=PICVRAM擪AhX

		MOV		#0, w10					;X(w10)=0
BSD0_LpX:
		CLR		w13
		TBLRDL.b [w9++], w13			;w13=MapChipԍ

BSD0_Wt:

	;MapChipAhXZo
		SL		w13, #5, w12		;MapChipAhX=p^[ԍ*MapChip̃f[^i#32j 
		ADD		w12, w8, w12		;                          +MapChipData擪AhX
		SL		w4, #2, w3
		ADD		w12, w3, w12
	;
		CALL	BSWr0
	;LCDVRAMAhX XZ
		ADD		w11, #4, w11				;LCDVRAMAhX XZ
	;LoopX`FbN
		ADD		w10,#8,W10
		MOV		#128,w6
		CPSEQ	w10, w6
		GOTO	BSD0_LpX

BSD1:
  ;(2)ʒ
  ;   NbsOsv
		MOV		#15, w0				;y݉
		MOV		w0, DrawY			;
BSD1_LpY:
		DEC		w5, w5
		MOV		#64, w6				;
		MUL.UU	w6, w5, w6
		ADD		w11, w6, w11
		MOV		#8, w5
		MOV		#0, w10				;X(w10)=0

BSD1_LpX:
		CLR		w13
		TBLRDL.b [w9++], w13		;w13=MapChipԍ

BSD1_Wt:

	;MapChipAhXZo
		SL		w13, #5, w12		;MapChipAhX=p^[ԍ*MapChip̃f[^i#32j 
		ADD		w12, w8, w12		;                          +MapChipData擪AhX
	;
		CALL	BSWr0
	;LCDVRAMAhX XZ
		ADD		w11, #4, w11				;LCDVRAMAhX XZ
	;LoopX`FbN
		ADD		w10,#8,W10
		MOV		#128,w6
		CPSEQ	w10, w6
		GOTO	BSD1_LpX
	;LoopY`FbN
		DEC		DrawY
		BRA		NZ, BSD1_LpY

BSD2:
  ;(3)ʉ[
  ;   XN[ʒuɂĂMapChip̉͂ݏoB̂߁ANbsO{

		DEC		w5, w5
		MOV		#64, w6				;
		MUL.UU	w6, w5, w6
		ADD		w11, w6, w11
		MOV		#0x0007, w0					;w10 = SclY[2:0]
		MOV		_SclY, w5
		AND		w5, w0, w5
		CP0		w5
		BRA		Z, BSD_End
	
		MOV		#0, w10				;X(w10)=0

BSD2_LpX:
		CLR		w13
		TBLRDL.b [w9++], w13		;w13=MapChipԍ

BSD2_Wt:

	;MapChipAhXZo
		SL		w13, #5, w12		;MapChipAhX=p^[ԍ*MapChip̃f[^i#32j 
		ADD		w12, w8, w12		;                          +MapChipData擪AhX
	;
		CALL	BSWr0
	;LCDVRAMAhX XZ
		ADD		w11, #4, w11				;LCDVRAMAhX XZ
	;LoopX`FbN
		ADD		w10,#8,W10
		MOV		#128,w6
		CPSEQ	w10, w6
		GOTO	BSD2_LpX

BSD_End:
		RETURN


;-------------------------------------------
;@PICVRAM̃I[NA
;-------------------------------------------
;w̐FPICVRAMI[NA
;F w0=pbgԍ
;ߒlF Ȃ

_VR_AllClr:
		MOV		#LVRAM, w11				;W11=PICVRAM擪AhX

		MOV		#4096, w4				;w4=PICVRAM݉
VRAC_Lp:

		MOV		w0, [w11++] 			;PICVRAM

	;Loop`FbN
		DEC		w4, w4
		BRA		NZ, VRAC_Lp

		RETURN
;-----------------------
;@wiCgohbkbcuq`l
;-----------------------
; ́@Fw11=LCDVramAdr, w12=MapChipAhX
;@@@@@Fw5=SizeY
BSWr0:
		PUSH	w5
		PUSH	w10
		PUSH	w11

		CLR		w1
		MOV		#60, w0
BSW0_LoopY:
		MOV		#8, w6					;SizeX=8
BSW0_LoopX:
	;f[^
		TBLRDL.b	[w12++], w1			;MapPicture Data(2dot)ǂݍ
		MOV.b	w1, [w11++] 			;LCD VRam

	;loopX`FbN
		DEC2	w6, w6
		BRA		NZ, BSW0_LoopX
	;loopY`FbN
		ADD		w11, w0, w11
		DEC		w5, w5
		BRA		NZ, BSW0_LoopY

	;I
		POP		w11
		POP		w10
		POP		w5
		RETURN

;-------------------------------------------
;@PICVRAMւ̃LN^`(XN[/NsOΉ)
;-------------------------------------------
;Fw0=XW,@w1=YW,w2=Lf[^擪AhX(table offset) ,w2=\p^[ԍ
;ߒlFȂ


_VR_ChrDraw:
		MOV		w0, w10			; w0@ w10
		MOV		w1, w11			; w1@ w11
		MOV		w2, w12			; w2@ w12
		MOV		w3, w13			; w3@ w13

	;ChrTCY,\p^[AhX
		CLR	w1
		CLR	w8
		CLR	w7
		TBLRDL.b [w12++], w8	;SizeXǂݍ (w8=SizeX)
		LSR		w8,#1, w8		;             SizeX /2(2dot1bytê)
		TBLRDL.b [w12++], w7	;SizeYǂݍ (w7=SizeY)
		MUL.UU	w8, w7, w0		;f[^     (w0 = SizeX/2 *SizeY)           
		MUL.UU	w13, w0, w0		;p^[AhX   (w0=f[^*p^[ԍ)
		ADD		w0, w12,w12		;Lf[^AhX (w12=Lf[^AhX+p^[AhX)

	;LCD VRAMAhXZo
					
		SL		w11, #6, w2		;LCDVRamAhX (w11 = LVRAMItZbgAhX	
		LSR		w10, #1, w10	;@                   + \x*64 + \X/2 )	
		ADD		w10, w2, w11
		MOV		#LVRAM, w1
		ADD		w11, w1, w11

	;Lf[^]
		CLR		w5
CD_LpY:
  	  ;Y Loop
		MOV		w8, w6			;w6=SizeX /2
CD_LpX:
		TBLRDL.b [w12++], w0	;w0=Lf[^(2hbg)
		MOV.b	[w11], w1		;w1=LCD VRAMf[^(wi̓Ǐo)
	  ;hbg
		MOV		#0x000F, w2		;hbg̃}XN(4bitEhbg)
		AND		w0, w2, w3		;Lf[^̍hbg(4bit)"0"Ȃwî܂
		CPSNE	w3, w5
		AND		w2, w1, w3		;
	  ;Ehbg
		MOV		#0x00F0, w2		;Ehbg̃}XN(4bithbg)
		AND		w0, w2, w4		;Lf[^̉Ehbg(4bit)"0"Ȃwî܂
		CPSNE	w4, w5
		AND		w1, w2, w4		;
	  ;E
		IOR		w3, w4, w3
	  ;LCD RAM֏߂
		MOV.b	w3, [w11++]	 			;LCD VRam
	  ;[v`FbN
		DEC		w6, w6					;X`FbN
		BRA		NZ, CD_LpX
		MOV		#64, w0					;LCDVRamAhXY+1
		SUB		w0, w8, w0
		ADD		w11, w0, w11
		DEC		w7, w7					;Y`FbN
		BRA		NZ, CD_LpY			

		RETURN
;-------------------------------------------
;@FwpPICVRAMւ̃LN^`(XN[/NsOΉ)
;-------------------------------------------
;Fw0=XW,@w1=YW,w2=Lf[^擪AhX(table offset) ,w3=\p^[ԍ
;    w4=\FpbgԍiLf[^̓FȊOwFœhԂ`悷j
;ߒlFȂ


_VR_ChrDrawC:
		MOV		w0, w10			; w0@ w10
		MOV		w1, w11			; w1@ w11
		MOV		w2, w12			; w2@ w12
		MOV		w3, w13			; w3@ w13
;		MOV		w4, w14			; w4@ w14

	;ChrTCY,\p^[AhX
		CLR	w1
		CLR	w8
		CLR	w7
		TBLRDL.b [w12++], w8	;SizeXǂݍ (w8=SizeX)
		LSR		w8,#1, w8		;             SizeX /2(2dot1bytê)
		TBLRDL.b [w12++], w7	;SizeYǂݍ (w7=SizeY)
		MUL.UU	w8, w7, w0		;f[^     (w0 = SizeX/2 *SizeY)           
		MUL.UU	w13, w0, w0		;p^[AhX   (w0=f[^*p^[ԍ)
		ADD		w0, w12,w12		;Lf[^AhX (w12=Lf[^AhX+p^[AhX)

	;LCD VRAMAhXZo
					
		SL		w11, #6, w2		;LCDVRamAhX (w11 = LVRAMItZbgAhX	
		LSR		w10, #1, w10	;@                   + \x*64 + \X/2 )	
		ADD		w10, w2, w11
		MOV		#LVRAM, w1
		ADD		w11, w1, w11

	;Lf[^]
		CLR		w5
CDC_LpY:
  	  ;Y Loop
		MOV		w8, w6			;w6=SizeX /2
CDC_LpX:
		TBLRDL.b [w12++], w0	;w0=Lf[^(2hbg)
		MOV.b	[w11], w1		;w1=LCD VRAMf[^(wi̓Ǐo)
	  ;hbg
		MOV		#0x000F, w2		;hbg̃}XN(4bitEhbg)
		AND		w0, w2, w3		;Lf[^̍hbg(4bit)"0"Ȃwî܂
		AND		w4, w2, w9		;wJ[ԍw9ɃZbg
		CPSNE	w3, w5
		AND		w2, w1, w9		;
		MOV		w9, w3
	  ;Ehbg
		SL		w4, #4, w9		;wJ[ԍw9(Ehbg)ɃZbg
		MOV		#0x00F0, w2		;Ehbg̃}XN(4bithbg)
		PUSH	w4
		AND		w0, w2, w4		;Lf[^̉Ehbg(4bit)"0"Ȃwî܂		
		CPSNE	w4, w5
		AND		w2, w1, w9		;
		MOV		w9, w4
	  ;E
		IOR		w3, w4, w3
		POP		w4
	  ;LCD RAM֏߂
		MOV.b	w3, [w11++]	 			;LCD VRam
	  ;[v`FbN
		DEC		w6, w6					;X`FbN
		BRA		NZ, CDC_LpX
		MOV		#64, w0					;LCDVRamAhXY+1
		SUB		w0, w8, w0
		ADD		w11, w0, w11
		DEC		w7, w7					;Y`FbN
		BRA		NZ, CDC_LpY			

		RETURN
;------------------------------------------
;@PICVRAMւ̃LN^`(XN[/NsOΉ)
;------------------------------------------
;Fw0=XW,@w1=YW,w2=Lf[^擪AhX(table offset) ,w2=\p^[ԍ
;ߒlFȂ
;@\F@LN^f[^PICLCD VRAMɓ]
;@@@@@ʂ͂ݏoꍇ̓NbsO{
;@@@@@cXN[ɑΉBScrlYYW̑ΉƂ\

_VR_ChrSclDraw:

		PUSH	w14

		MOV		w0, w10			; w0@ w10
		MOV		w1, w11			; w1@ w11
		MOV		w2, w12			; w2@ w12
		MOV		w3, w13			; w3@ w13
	;ChrTCY,\p^[AhX
		CLR	w1
		CLR	w8
		CLR	w7
		TBLRDL.b [w12++], w8	;SizeXǂݍ (w8=SizeX)
		LSR		w8,#1, w8		;             SizeX /2(2dot1bytê)
		TBLRDL.b [w12++], w7	;SizeYǂݍ (w7=SizeY)
		MUL.UU	w8, w7, w0		;f[^     (w0 = SizeX/2 *SizeY)           
		MUL.UU	w13, w0, w0		;p^[AhX   (w0=f[^*p^[ԍ)
		ADD		w0, w12,w12		;Lf[^AhX (w12=Lf[^AhX+p^[AhX)

	;LCD VRAMAhXZo
		MOV		_SclY, w0
		SUB		w11, w0, w11	;XN[Wɕϊ(w11 = YW-SclY)			
		MOV		#64, w2
		MUL.SS	w11, w2, w2		;LCDVRamAhX (w14 = LVRAMItZbgAhX	
		MOV		#LVRAM, w1		;@                   + \x*64 + \X/2 )	
		ADD		w2, w1, w1
		MOV		w10, w9			
		BTSC	w10, #15
		NEG		w10, w9
		LSR		w9, #1, w9
		ADD		w9, w1, w14
		BTSC	w10, #15
		SUB		w1, w9, w14


	;Lf[^]
		CLR		w5
CSD_LpY:
  	  ;Y Loop
		MOV		w8, w6			;w6=SizeX /2
		MOV		w10, w9			;w9=X
CSD_LpX:
	  ;NbsO@0<X<127,0<Y<127͈͓̔̂Ƃ]
		MOV		#127, w1
		BTSC	w9, #15			;if x<0
		GOTO	CSD_Clip		;   then goto NbsO
		CPSGT	w1, w9			;if x>127
		GOTO	CSD_Clip		;   then goto NbsO
		BTSC	w11, #15		;if y<0
		GOTO	CSD_Clip		;   then goto NbsO
		CPSGT	w1, w11			;if y>127
		GOTO	CSD_Clip		;   then goto NbsO

		GOTO	CSD_LpX_wr
CSD_Clip:
		INC		w12, w12
		INC		w14, w14
		GOTO	CSD_LpX_Ck
CSD_LpX_wr:
	  ;]Jn
		TBLRDL.b [w12++], w0	;w0=Lf[^(2hbg)
		MOV.b	[w14], w1		;w1=LCD VRAMf[^(wi̓Ǐo)
	  ;hbg
		MOV		#0x000F, w2		;hbg̃}XN(4bitEhbg)
		AND		w0, w2, w3		;Lf[^̍hbg(4bit)"0"Ȃwî܂
		CPSNE	w3, w5
		AND		w2, w1, w3		;
	  ;Ehbg
		MOV		#0x00F0, w2		;Ehbg̃}XN(4bithbg)
		AND		w0, w2, w4		;Lf[^̉Ehbg(4bit)"0"Ȃwî܂
		CPSNE	w4, w5
		AND		w1, w2, w4		;
	  ;E
		IOR		w3, w4, w3
	  ;LCD RAM֏߂
		MOV.b	w3, [w14++]	 	;LCD VRam
CSD_LpX_Ck:
	  ;[v`FbN
		INC2	w9, w9			;X+2
		DEC		w6, w6			;X`FbN
		BRA		NZ, CSD_LpX
		MOV		#64, w0			;LCDVRamAhXY+1
		SUB		w0, w8, w0
		ADD		w14, w0, w14
		INC		w11, w11		;Y+1
		DEC		w7, w7			;Y`FbN
		BRA		NZ, CSD_LpY			

		POP		w14


		RETURN

;--------------------------------------------------
;@PICVRAMւ̕`(XN[/NsOΉ)
;--------------------------------------------------
;Fw0=XW,@w1=YW,w2=\p^[ԍ, w3=wiFpbgԍ(0:)/\Fpbgԍ , w4=tHg0or1
;ߒlFȂ
_VR_MojiDraw:
		PUSH	w14
		BTSC	w4, #0
		GOTO	Moji_Fnt1
		MOV		#tblpage(Fnt0),w4		;w8=ʃpbgi[AhX
		MOV		w4, _TBLPAG				;
		MOV		#tbloffset(Fnt0),w4		;
		GOTO	Moji_30
Moji_Fnt1:
		MOV		#tblpage(Fnt1),w4		;w8=ʃpbgi[AhX
		MOV		w4, _TBLPAG				;
		MOV		#tbloffset(Fnt1),w4		;

Moji_30:;"0"
		MOV		#0x30, w10
		CPSNE	w2, w10
		MOV		#0, w13
Moji_31:;"1"
		MOV		#0x31, w10
		CPSNE	w2, w10
		MOV		#1, w13
Moji_32:;"2"
		MOV		#0x32, w10
		CPSNE	w2, w10
		MOV		#2, w13
Moji_33:;"3"
		MOV		#0x33, w10
		CPSNE	w2, w10
		MOV		#3, w13
Moji_34:;"4"
		MOV		#0x34, w10
		CPSNE	w2, w10
		MOV		#4, w13
Moji_35:;"5"
		MOV		#0x35, w10
		CPSNE	w2, w10
		MOV		#5, w13
Moji_36:;"6"
		MOV		#0x36, w10
		CPSNE	w2, w10
		MOV		#6, w13
Moji_37:;"7"
		MOV		#0x37, w10
		CPSNE	w2, w10
		MOV		#7, w13
Moji_38:;"8"
		MOV		#0x38, w10
		CPSNE	w2, w10
		MOV		#8, w13
Moji_39:;"9"
		MOV		#0x39, w10
		CPSNE	w2, w10
		MOV		#9, w13
Moji_20:;" "
		MOV		#0x20, w10
		CPSNE	w2, w10
		MOV		#10, w13
Moji_41:;"A"
		MOV		#0x41, w10
		CPSNE	w2, w10
		MOV		#11, w13
Moji_42:;"B"
		MOV		#0x42, w10
		CPSNE	w2, w10
		MOV		#12, w13
Moji_43:;"C"
		MOV		#0x43, w10
		CPSNE	w2, w10
		MOV		#13, w13
Moji_44:;"D"
		MOV		#0x44, w10
		CPSNE	w2, w10
		MOV		#14, w13
Moji_45:;"E"
		MOV		#0x45, w10
		CPSNE	w2, w10
		MOV		#15, w13
Moji_46:;"F"
		MOV		#0x46, w10
		CPSNE	w2, w10
		MOV		#16, w13
Moji_47:;"G"
		MOV		#0x47, w10
		CPSNE	w2, w10
		MOV		#17, w13
Moji_48:;"H"
		MOV		#0x48, w10
		CPSNE	w2, w10
		MOV		#18, w13
Moji_49:;"I"
		MOV		#0x49, w10
		CPSNE	w2, w10
		MOV		#19, w13
Moji_4a:;"J"
		MOV		#0x4a, w10
		CPSNE	w2, w10
		MOV		#20, w13
Moji_4b:;"K"
		MOV		#0x4b, w10
		CPSNE	w2, w10
		MOV		#21, w13
Moji_4c:;"L"
		MOV		#0x4c, w10
		CPSNE	w2, w10
		MOV		#22, w13
Moji_4d:;"M"
		MOV		#0x4d, w10
		CPSNE	w2, w10
		MOV		#23, w13
Moji_4e:;"N"
		MOV		#0x4e, w10
		CPSNE	w2, w10
		MOV		#24, w13
Moji_4f:;"O"
		MOV		#0x4f, w10
		CPSNE	w2, w10
		MOV		#25, w13
Moji_50:;"P"
		MOV		#0x50, w10
		CPSNE	w2, w10
		MOV		#26, w13
Moji_51:;"Q"
		MOV		#0x51, w10
		CPSNE	w2, w10
		MOV		#27, w13
Moji_52:;"R"
		MOV		#0x52, w10
		CPSNE	w2, w10
		MOV		#28, w13
Moji_53:;"S"
		MOV		#0x53, w10
		CPSNE	w2, w10
		MOV		#29, w13
Moji_54:;"T"
		MOV		#0x54, w10
		CPSNE	w2, w10
		MOV		#30, w13
Moji_55:;"U"
		MOV		#0x55, w10
		CPSNE	w2, w10
		MOV		#31, w13
Moji_56:;"V"
		MOV		#0x56, w10
		CPSNE	w2, w10
		MOV		#32, w13
Moji_57:;"W"
		MOV		#0x57, w10
		CPSNE	w2, w10
		MOV		#33, w13
Moji_58:;"X"
		MOV		#0x58, w10
		CPSNE	w2, w10
		MOV		#34, w13
Moji_59:;"Y"
		MOV		#0x59, w10
		CPSNE	w2, w10
		MOV		#35, w13
Moji_5a:;"Z"
		MOV		#0x5a, w10
		CPSNE	w2, w10
		MOV		#36, w13
Moji_21:;"!"
		MOV		#0x21, w10
		CPSNE	w2, w10
		MOV		#37, w13
Moji_2d:;"-"
		MOV		#0x2d, w10
		CPSNE	w2, w10
		MOV		#38, w13
Moji_2f:;"/"
		MOV		#0x2f, w10
		CPSNE	w2, w10
		MOV		#39, w13
Moji_22:;"""
		MOV		#0x22, w10
		CPSNE	w2, w10
		MOV		#40, w13
Moji_2e:;"."
		MOV		#0x2e, w10
		CPSNE	w2, w10
		MOV		#41, w13

Moji_End:
		MOV		w13, w2

		POP		w14
		GOTO	_VR_ChrDraw2C	
;--------------------------------------------------
;@2FLf[^@PICVRAMւ̕`(XN[/NsOΉ)
;--------------------------------------------------
;Fw0=XW,@w1=YW ,w2=\p^[ԍ,w3=[7:4]wiFpbgԍ(0:)/[3:0]\Fpbgԍ
;    ,w4=Lf[^擪AhX(table offset)
;ߒlFȂ


_VR_ChrDraw2C:
		PUSH	w0
		PUSH	w1
		PUSH	w3
		PUSH	w6
		PUSH	w7
		PUSH	w14

		MOV		w0, w10			; w0(X)@ w10
		MOV		w1, w11			; w1(Y)@ w11
		MOV		w4, w12			; w4(Chr Data Adr)@ w12
		MOV		w2, w13			; w2(Ptn)@ w13
		MOV		#0x000F, w0		; w4[3:0])(\F)@ w14
		AND		w3, w0, w14		;
		MOV		#0x00F0, w0		; w7[7:4](wiF)@ w9
		AND		w3, w0, w1		;
		LSR		w1, #4, w9		;
		IOR		w1, w9, w9

	;ChrTCY,\p^[AhX
		CLR	w1
		CLR	w8
		CLR	w7
		TBLRDL.b [w12++], w8	;SizeXǂݍ (w8=SizeX)
		LSR		w8,#3, w8		;             SizeX /8(8dot1bytê)
		TBLRDL.b [w12++], w7	;SizeYǂݍ (w7=SizeY)
		MUL.UU	w8, w7, w0		;f[^     (w0 = SizeX/8 *SizeY)           
		MUL.UU	w13, w0, w0		;p^[AhX   (w0=f[^*p^[ԍ)
		ADD		w0, w12,w12		;Lf[^AhX (w12=Lf[^AhX+p^[AhX)

	;LCD VRAMAhXZo
					
		SL		w11, #6, w2		;LCDVRamAhX (w11 = LVRAMItZbgAhX	
		LSR		w10, #1, w10	;@                   + \x*64 + \X/2 )	
		ADD		w10, w2, w11
		MOV		#LVRAM, w1
		ADD		w11, w1, w11

	;Lf[^]
		CLR		w5
CD2_LpY:
  	  ;Y Loop
		MOV		w8, w6			;w6=SizeX /8
CD2_LpX:
		TBLRDL.b [w12++], w0	;w0=Lf[^(8hbg)
		MOV.b	[w11], w1		;w1=LCD VRAMf[^(wi̓Ǐo)

		CLR		w2				;wiFpbg !=0()Ȃwif[^wiFɏ㏑
		CPSEQ	w9, w2			;
		MOV		w9, w1			;

	  ;hbg1
		MOV		#0x00F0, w2		;Lf[^ bit1=1Ȃ\Fpbgԍ
		AND		w1, w2, w2		;wif[^ɏ㏑
		SL		w14, #4, w3		;
		BTSC	w0, #1			;
		MOV		w3, w2			;
	  ;hbg0
		MOV		#0x000F, w4		;Lf[^ bit0=1Ȃ\Fpbgԍ
		AND		w1, w4, w4		;wif[^ɏ㏑
		MOV		w14, w3			;
		BTSC	w0, #0			;
		MOV		w3, w4			;
	  ;hbg0,1
		IOR		w2, w4, w3
	  ;LCD RAM֏߂
		MOV.b	w3, [w11++]	 			;LCD VRam

		MOV.b	[w11], w1		;w1=LCD VRAMf[^(wi̓Ǐo)

		CLR		w2				;wiFpbg !=0()Ȃwif[^㏑
		CPSEQ	w9, w2			;
		MOV		w9, w1			;

	  ;hbg3
		MOV		#0x00F0, w2		;Lf[^ bit3=1Ȃ\Fpbgԍ
		AND		w1, w2, w2		;wif[^ɏ㏑
		SL		w14, #4, w3		;
		BTSC	w0, #3			;
		MOV		w3, w2		;
	  ;hbg2
		MOV		#0x000F, w4		;Lf[^ bit2=1Ȃ\Fpbgԍ
		AND		w1, w4, w4		;wif[^ɏ㏑
		MOV		w14, w3			;
		BTSC	w0, #2			;
		MOV		w3, w4			;
	  ;hbg2,3
		IOR		w2, w4, w3
	  ;LCD RAM֏߂
		MOV.b	w3, [w11++]	 			;LCD VRam

		MOV.b	[w11], w1		;w1=LCD VRAMf[^(wi̓Ǐo)

		CLR		w2				;wiFpbg !=0()Ȃwif[^㏑
		CPSEQ	w9, w2			;
		MOV		w9, w1			;

	  ;hbg5
		MOV		#0x00F0, w2		;Lf[^ bit5=1Ȃ\Fpbgԍ
		AND		w1, w2, w2		;wif[^ɏ㏑
		SL		w14, #4, w3		;
		BTSC	w0, #5			;
		MOV		w3, w2			;
	  ;hbg4
		MOV		#0x000F, w4		;Lf[^ bit4=1Ȃ\Fpbgԍ
		AND		w1, w4, w4		;wif[^ɏ㏑
		MOV		w14, w3			;
		BTSC	w0, #4			;
		MOV		w3, w4			;
	  ;hbg4,5
		IOR		w2, w4, w3
	  ;LCD RAM֏߂
		MOV.b	w3, [w11++]	 			;LCD VRam

		MOV.b	[w11], w1		;w1=LCD VRAMf[^(wi̓Ǐo)

		CLR		w2				;wiFpbg !=0()Ȃwif[^㏑
		CPSEQ	w9, w2			;
		MOV		w9, w1			;

	  ;hbg7
		MOV		#0x00F0, w2		;Lf[^ bit7=1Ȃ\Fpbgԍ
		AND		w1, w2, w2		;wif[^ɏ㏑
		SL		w14, #4, w3		;
		BTSC	w0, #7			;
		MOV		w3, w2			;
	  ;hbg6
		MOV		#0x000F, w4		;Lf[^ bit6=1Ȃ\Fpbgԍ
		AND		w1, w4, w4		;wif[^ɏ㏑
		MOV		w14, w3			;
		BTSC	w0, #6			;
		MOV		w3, w4			;
	  ;hbg6,7
		IOR		w2, w4, w3
	  ;LCD RAM֏߂
		MOV.b	w3, [w11++]	 			;LCD VRam


	  ;[v`FbN
		DEC		w6, w6					;X`FbN
		BRA		NZ, CD2_LpX
		MOV		#64, w0					;LCDVRamAhXY+1
		SL		w8, #2, w1
		SUB		w0, w1, w0
		ADD		w11, w0, w11
		DEC		w7, w7					;Y`FbN
		BRA		NZ, CD2_LpY			

		POP	w14
		POP	w7
		POP	w6
		POP	w3
		POP	w1
		POP	w0
		RETURN
;***************************************************************
;LCD\֘A
;***************************************************************
;-------------------------------------
;ʃNA(NAFw)
;-------------------------------------
;F@W0=Fl(12bit=RRRRGGGGBBBB)
;ߒlF@Ȃ

_LCD_CLS:
;LCD VRAM ALL CLR
	;CASET
		mLCDCMD	#CASET
		mLCDDAT #0				;Start
		mLCDDAT #2
		mLCDDAT #0				;END
		mLCDDAT #129

	;RASET
		mLCDCMD	#RASET
		mLCDDAT #0				;Start
		mLCDDAT #1
		mLCDDAT #0				;END
		mLCDDAT #128

	;RAMWR
		mLCDCMD	#RAMWR
		MOV		#8192, w10

		LSR		w0, #4,w2		;w1=hbg RRRRGGGG
		SL		w0, #4,w3
		LSR		w0, #8,w4
		AND		w3, w4, w3		;w2=hbgBBBB & EhbgRRRR

CLS_Loop:
		MOV		w2, w1			
		CALL	LCD_SendDat
		MOV		w3, w1
		CALL	LCD_SendDat
		MOV		w0, w1
		CALL	LCD_SendDat
		DEC		w10, w10
		BRA		NZ, CLS_Loop

		RETURN

;-----------------------
;@LCDR}hCg
;-----------------------
; ́@F w1=LCD]R}h
LCD_SendCmd:
		BTSC	PMMODE, #BUSY		;Busy check
		GOTO	LCD_SendCmd
;		BCLR	PMADDR, #14			;PMADR bit14=Dt/~CMD 
		BCLR	LATA, #10			;DATA/~CMD = 0(CMD) 
		MOV		w1, PMDIN1
		RETURN

;-----------------------
;@LCDf[^Cg
;-----------------------
; ́@F w1=LCD]f[^
LCD_SendDat:
		BTSC	PMMODE, #BUSY		;Busy check
		GOTO	LCD_SendDat
;		BSET	PMADDR, #14			;PMADR bit14=Dt/~CMD 
		BSET	LATA, #10			;DATA/~CMD = 1(DATA)
		MOV		w1, PMDIN1
		RETURN

;-----------------------
;@EFCg
;-----------------------
;w1=EFCg(1`0xFFFF)
Wait1u:
		NOP
		DEC		w1,w1
		BRA		NZ,Wait1u

		RETURN

;w0=EFCgʃ[h(1`0xFFFF)
_Wait_ms:
		MOV		 #8000, w2		;w2=EFCgʃ[h
Wait_ms00:
		NOP
		NOP
		NOP
		DEC		w2,w2
		BRA		NZ,Wait_ms00
		DEC		w0,w0
		BRA		NZ,_Wait_ms

		RETURN

;***************************************************************
;TEh֘A
;***************************************************************
;==========================
;TEh PWMɂPCM0 o͏ݒ
;==========================
;Fw0=SounDataAddress tblpage, W1=SounDataAddress tbloffset
;ߒlFȂ
_SndSetPCM0:
		MOV		w0, w3
		MOV		w1, w4
		MOV		#_Snd0_ST+4, w0
;		MOV		#tblpage(_Shot0),w3			;TEhf[^
		MOV		w3, [w0++]					;tblpageSnd0_ST +4,5ɐݒ
		MOV		w3, _TBLPAG
;		MOV		#tbloffset(_Shot0),w3		;tbloffsetSnd0_ST +6,7ɐݒ
		MOV		w4, [w0++]					;
		MOV		#_Snd0_ST+2, w0
		TBLRDL	[w4], w1					;_Snd_ST +2,3 = Data
		SL		w1, #1, w1
		MOV		w1,[w0]						;
		MOV		#3,w3						;CfbNXJE^=3
		MOV		#_Snd0_ST,w0				;
		MOV		w3,[w0++]					;		
		BSET	_Snd_St, #0					;_Snd_St bit0 = 1

		BTSC	T2CON, #TON					;^C}[2쒆ȂReturn
		RETURN								;~Ȃ瓮Jn
		MOV		#1,w0						;
		MOV		w0, OC1R					;オl(_~[)=1 
		MOV		#2,w0						;
		MOV		w0, OC1RS					;l(_~[)=2 
		MOV		#0xFFFF,w0					;
		MOV		w0, PR2						;(_~[) =0xFFFF
		MOV		w0, TMR2					;^C}[2[NA
		BSET	SndSel, #0
		BSET	T2CON, #TON					;^C}[2Jn	
		RETURN

;==========================
;TEh PWMɂPCM1 o͏ݒ
;==========================
;Fw0=SounDataAddress tblpage, W1=SounDataAddress tbloffset
;ߒlFȂ
_SndSetPCM1:
		MOV		w0, w3
		MOV		w1, w4
		MOV		#_Snd1_ST+4, w0
;		MOV		#tblpage(_Hit0),w3			;TEhf[^
		MOV		w3, [w0++]					;tblpageSnd0_ST +4,5ɐݒ
		MOV		w3, _TBLPAG
;		MOV		#tbloffset(_Hit0),w3		;tbloffsetSnd0_ST +6,7ɐݒ
		MOV		w4, [w0++]					;
		MOV		#_Snd1_ST+2, w0
		TBLRDL	[w4], w1					;_Snd_ST +2,3 = Data
		SL		w1, #1, w1
		MOV		w1,[w0]						;
		MOV		#3,w3						;CfbNXAhX=3
		MOV		#_Snd1_ST,w0				;
		MOV		w3,[w0++]					;		
		BSET	_Snd_St, #1					;_Snd_St bit1 = 1

		BTSC	T2CON, #TON					;^C}[2쒆ȂReturn
		RETURN								;~Ȃ瓮Jn
		MOV		#1,w0						;
		MOV		w0, OC1R					;オl(_~[)=1 
		MOV		#2,w0						;
		MOV		w0, OC1RS					;l(_~[)=2 
		MOV		#0xFFFF,w0					;
		MOV		w0, PR2						;(_~[) =0xFFFF
		MOV		w0, TMR2					;^C}[2[NA
		BSET	SndSel, #0
		BSET	T2CON, #TON					;^C}[2Jn	
		RETURN

;==========================
;TEh PWM o͏ݒ
;==========================
_SndSet0:
		MOV		#1,w3						;U=0
		MOV		#_Snd0_ST,w0					;
		MOV		w3,[w0++]					;		
		INC2	w0, w0						;
		INC2	w0, w0						;
		INC2	w0, w0						;
		MOV		#0, w3						;CfbNXAhX=0
		MOV		w3, [w0]					;		
		MOV		#1,w0						;
		MOV		w0, OC1R					;オl(_~[)=1 
		MOV		#2,w0						;
		MOV		w0, OC1RS					;l(_~[)=2 
		MOV		#0xFFFF,w0					;
		MOV		w0, PR2						;(_~[) =0xFFFF
		MOV		w0, TMR2					;^C}[2[NA
		BCLR	SndSel, #0
		BSET	T2CON, #TON					;^C}[2Jn
		RETURN
;***************************************************************
;ݏ
;***************************************************************
;==========================
;OC1
;==========================
__OC1Interrupt:
		PUSH	w0
		PUSH	w1
		PUSH	w2
		PUSH	w3
		PUSH	w4
	;Select PWM Direct or PCM Snd
		BTSS	SndSel, #0
		GOTO	OC1INT_PWMDirect
OC1INT_PCM:		
	;Snd0
		CLR		w4
		BTSS	_Snd_St, #0			;_Snd_St bit0 = 0Ȃ	Snd1
		GOTO	OC1INT_Snd1				;
		MOV		#_Snd0_ST, w0		;
		MOV		[w0], w2			;CfbNXAhX +1 != CfbNXIAhXȂ
		INC		w2, w2				;TEhf[^ݒ
		MOV		w2, [w0++]			;
		MOV		[w0++], w3			;
		CP		w2, w3				;
		BRA		NZ, OC1INT_Snd0Set	;
	;TEh0I
		BCLR	_Snd_St, #0			;_Snd_St bit0 = 0
		CP0		_Snd_St
		BRA		Z, OC1INT_sndend	;STEho͒~B^C}[2~
		GOTO	OC1INT_Snd1
OC1INT_Snd0Set:
	;TEh0f[^ݒ
		LSR		w2, #1, w2
		MOV		[w0++], w1 			;w1 = tblpage(_Snd_ST +4,5)
		MOV		w1, _TBLPAG			;TBLPAGݒ		
		MOV		[w0++], w1 			;w1=tbloffset(_Snd_ST +6,7)
		ADD		w2, w1, w1			;w1=tbloffset + index
		CLR		w4
		TBLRDL.b	[w1++], w4		;w2 = TEhf[^

OC1INT_Snd1:
	;Snd1
		CLR		w2
		BTSS	_Snd_St, #1			;_Snd_St bit1 = 0Ȃ	RegSet
		GOTO	OC1INT_AddSnd			;
		MOV		#_Snd1_ST, w0		;
		MOV		[w0], w2			;CfbNXAhX +1 != CfbNXIAhXȂ
		INC		w2, w2				;TEhf[^ݒ
		MOV		w2, [w0++]			;
		MOV		[w0++], w3			;
		CP		w2, w3				;
		BRA		NZ, OC1INT_Snd1Set	;
	;TEh1I
		BCLR	_Snd_St, #1			;_Snd_St bit1 = 0
		CP0		_Snd_St
		BRA		Z, OC1INT_sndend	;STEho͒~B^C}[2~
		GOTO	OC1INT_AddSnd
OC1INT_Snd1Set:
	;TEh1f[^ݒ
		LSR		w2, #1, w2
		MOV		[w0++], w1 			;w1 = tblpage(_Snd_ST +4,5)
		MOV		w1, _TBLPAG			;TBLPAGݒ		
		MOV		[w0++], w1 			;w1=tbloffset(_Snd_ST +6,7)
		ADD		w2, w1, w1			;w1=tbloffset + index
		CLR		w2
		TBLRDL.b	[w1++], w2		;w2 = TEhf[^

OC1INT_AddSnd:
	;Snd0̂
		MOV		w4, w3
		MOV		_Snd_St, w0
		MOV		#1, w1
		CP		w0, w1
		BRA		Z, OC1INT_RegSet
	;Snd1̂
		MOV		w2, w3
		MOV		#2, w1
		CP		w0, w1
		BRA		Z, OC1INT_RegSet
;		SL		w2, #1, w2
	;Snd0,1 
		MOV		w2, w3
		BCLR	w3, #7
		ADD		w4, w3, w3
		MOV		#0x00FF, w0
		XOR		w2, w0, w0
		BCLR	w0, #7
		BTSS	w2, #7
		SUB		w4, w0, w3
		BTSC	w3, #15
		CLR		w3
		MOV		#0x00FF, w0
		BTSC	w3, #8
		MOV		w0, w3
		GOTO	OC1INT_RegSet
OC1INT_RegSet:
		MOV		#320, w0
		LSR		W3, #2, W4			;w3*1.25
		ADD		w3, w4, w3
		SUB		w0, w3, w2
		MOV		w0, PR2				;PR2ɐݒ
		MOV		w0, OC1RS			;OC1RSɐݒ(l)
		MOV		w2, OC1R			;/2OC1RSɐݒ(オl)				
		GOTO	OC1INT_End
		GOTO	OC1INT_sndend

OC1INT_PWMDirect:
		MOV		#_Snd0_ST, w0		;
		MOV		[w0], w1			;UJE^-1="0"łȂ
		DEC		w1, w1				;荞ݏI
		MOV		w1, [W0++]			;
		BRA		NZ, OC1INT_End		;"0"Ȃ,
OC1INT_setdt:
	;TEhf[^ݒ
		INC2	w0, w0				;̃TEhf[^TEhXe[^Xɐݒ		
		MOV		[w0++], w1 			;
		MOV		w1, _TBLPAG			;TBLPAGݒ		
		MOV		[w0++], w1 			;w1=tbloffset
		MOV		[w0], w2			;w2=index
		PUSH	w2
		INC2	w2, w2				;Snd_ST(index)=+2
		INC2	w2, w2				;Snd_ST(index)=+2
		MOV		w2, [w0++]			;
		POP		w2
		ADD		w2, w1, w1			;w1=tbloffset + index
		TBLRDL	[w1++], w2			;w2 = TEhf[^(U)
		MOV		#0xFFFF, w3			;
		CPSNE	w2, w3				;U=0xFFFFȂ
		GOTO	OC1INT_sndend		;TEho͏I
		MOV		#0xFFFE, w3			;
		CPSNE	w2, w3				;U=0xFFFEȂ
		GOTO	OC1INT_sndloop		;TEh[v
		MOV		#_Snd0_ST, w0		;
		MOV		w2, [w0++]			;U񐔂Snd_stɐݒ
		TBLRDL	[w1++], w2			;w2 = TEhf[^()
		MOV		#0, w3			;
		CPSNE	w2, w3				;=0Ȃ
		GOTO	OC1INT_setnosnd		;ݒ		
		MOV		w2, [w0++]			;Snd_stɐݒ
		MOV		w2, PR2				;PR2ɐݒ
		MOV		w2, OC1RS			;OC1RSɐݒ(l)
		LSR		w2, w2				;
		MOV		w2, OC1R			;/2OC1RSɐݒ(オl)				
		GOTO	OC1INT_End
OC1INT_setnosnd:
	;ݒ
		MOV		#1000, w2
		MOV		w2, [w0++]			;Snd_stɐݒ
		MOV		w2, PR2				;PR2ɐݒ
;		DEC		w2, w2
		MOV		w2, OC1RS			;OC1RSɐݒ(l)
		DEC		w2, w2				;
		MOV		w2, OC1R			;オłȂlݒ				
		GOTO	OC1INT_End
OC1INT_sndloop:
		MOV		#0, w3				;Xe[^XWX^
		MOV		#_Snd0_ST+8, w0		;CfNXAhX="0"ɂ
		MOV		w3, [w0]			;TEhf[^ݒ
		MOV		#_Snd0_ST+2, w0		;
		GOTO	OC1INT_setdt		;



OC1INT_sndend:
	;g`o͒~
		BCLR	T2CON, #TON			;^C}[2~		

OC1INT_End:
        BCLR IFS0, #OC1IF          ;݃tONA
 
		POP		w4
		POP		w3
		POP		w2                          
		POP		w1
		POP		w0
	
        RETFIE   

;***************************************************************
;̑
;***************************************************************
;==========================
;1610iϊ
;==========================
;w2 = ϊ16i̒l
;߂lF t@CWX^ H2D_1,10,100,1000,10000ɊeẌʂ̒li[

H2D:
		PUSH	w0
		PUSH	w1
		PUSH	w2
		PUSH	w3
		PUSH	w4

		MOV		w2, w0
		MOV		#4, w5
		MOV		#10, w3
		MOV		#H2D_1, w4
H2D_Lp:
		MOV		w0, w2
		REPEAT	#17
		DIV.U	w2, w3
		MOV.b	w1,[w4++]
		DEC		w5,w5
		CP		w5, #0
		BRA		NZ, H2D_Lp
		MOV.b	w0,[w4]

		POP		w4
		POP		w3
		POP		w2
		POP		w1
		POP		w0
		RETURN
;==========================
;l\(5)
;==========================
;Fw0=XW,@w1=YW,w2=\鐔, w3=wiFpbgԍ(0:)/\Fpbgԍ , w4=tHgTCY0or1
;ߒlFȂ

_VR_NumDrw:
		CALL	H2D						;XRA1610iϊ
		MOV		#5, w6					;p[vJE^(5)
		MOV		#H2D_10000, w7			;
		CLR		w5	
		BTSC	w4, #0
		GOTO	NumWr_Fnt1					
	;Font0
		MOV		#tblpage(Fnt0),w4		;f[^i[AhX
		MOV		w4, _TBLPAG				;
		MOV		#tbloffset(Fnt0),w4		;
		MOV		#4, w8					;̂wTCY=4
		GOTO	NumWr_Lp
NumWr_Fnt1:
	;Font1
		MOV		#tblpage(Fnt1),w4		;f[^i[AhX
		MOV		w4, _TBLPAG				;
		MOV		#tbloffset(Fnt1),w4		;
		MOV		#8, w8					;̂wTCY=8

NumWr_Lp:
		CLR		w2
		MOV.b	[w7--], w2				;w2=eʂ̒l
		CP		w6, #1
		BRA		Z, NumWr_0
		IOR		w5, w2, w5
		CP0		w5
		BRA		NZ, NumWr_0
		MOV		#10, w2
NumWr_0:
		PUSH	w4
		PUSH	w5
		PUSH	w8
		CALL	_VR_ChrDraw2C			; 2FL`
		POP		w8
		POP		w5
		POP		w4
NumWr_1:
		ADD		w8, w0, w0				;\X +8
		DEC		w6, w6
		CP0		w6
		BRA		NZ, NumWr_Lp
		RETURN

;==========================
;tbV
;==========================
;w12= ݃AhX, w2= ݃f[^i[̃AhX
Fls_wt:
	;tbV 
		MOV		#0x4042, W0
		MOV		W0, NVMCON 
		TBLWTL	W12, [W12] 
		DISI	#5 							;L[bN̊ԁA݋֎~(5+1cyc)
		MOV		#0x55, W0
		MOV		W0, NVMKEY
		MOV		#0xAA, W1
		MOV		W1, NVMKEY
		BSET	NVMCON, #WR 
		NOP 
		NOP
Fls_wt_Lp0:
		BTSC	NVMCON, #WR
		GOTO	Fls_wt_Lp0

	;tbV
		MOV		#8, w1
Fls_wt_Lp1:
		CLR		w3
		MOV		[w2++], w5
		TBLWTL	W5, [W12] 					;
		TBLWTH	W3, [W12++] 				; 
		DEC		w1, w1
		BRA		NZ, Fls_wt_Lp1
		MOV		#63, w0
		MOV		#0xFFFF,w2
		MOV		#0x4001, W0 				;
		MOV		W0, NVMCON 					;
		DISI	#5 							;L[bN̊ԁA݋֎~(5+1cyc)
		MOV		#0x55, W0 					;
		MOV 	W0, NVMKEY
		MOV		#0xAA, W0
		MOV		W0, NVMKEY
		BSET	NVMCON, #WR					;
		NOP
		NOP
Fls_wt_Lp:
		BTSC	NVMCON, #WR
		GOTO	Fls_wt_Lp
		RETURN

;==========================
;gbvXRÃtbV
;==========================
_GTSWr:
	;gbvXRÃtbV
;		MOV		#1234, w0
;		MOV		w0, _GTS0

		MOV		#1,w12				;TBLPAG=0
		MOV		w12, _TBLPAG		;݃AhX=0x6000
		MOV		#0x0800,w12			;
		MOV		#_GTS0, W2 			;tbV݃f[^()
;		MOV		#0, W3 				;tbV݃f[^()
		GOTO	Fls_wt
;==========================
;gbvXRÃtbVǏo
;==========================
_GTSRd:
	;_\
	;gbvXRA̓Ǐo
		MOV		#1,w12				;TBLPAG=0
		MOV		w12, _TBLPAG		;ǏoAhX=0x6000
		MOV		#0x0800,w12			;
		CLR		w0		
		TBLRDL	[w12++], w0
		MOV		#0xFFFF,w1
		CPSNE	w0, w1
		CLR		w0			
		MOV		w0, _GTS0		;
		TBLRDL	[w12++], w0
		CPSNE	w0, w1
		CLR		w0			
		MOV		w0, _GTS1		;
		TBLRDL	[w12++], w0
		CPSNE	w0, w1
		CLR		w0			
		MOV		w0, _GTS2		;
		TBLRDL	[w12++], w0
		CPSNE	w0, w1
		CLR		w0			
		MOV		w0, _GTS3		;
		TBLRDL	[w12++], w0
		CPSNE	w0, w1
		CLR		w0			
		MOV		w0, _GTS4		;
		TBLRDL	[w12++], w0
		CPSNE	w0, w1
		CLR		w0			
		MOV		w0, _GTS5		;
		TBLRDL	[w12++], w0
		CPSNE	w0, w1
		CLR		w0			
		MOV		w0, _GTS6		;
		TBLRDL	[w12++], w0
		CPSNE	w0, w1
		CLR		w0			
		MOV		w0, _GTS7		;
		RETURN
;***************************************************************
;LATEhȂf[^
;***************************************************************
;==================================================
;Chr Data
;==================================================
	.include "ChrDataCmn.inc"
	.include "ChrData.inc"
;==========================
;TEhf[^
;==========================
.global	_snd_piggy

_snd_piggy:
		.word	  50,0x3000 	;h 
		.word	 400,0x0000 	;
		.word	 200,0x1500 	;h 
		.word	  10,0x0000 	;
		.word	0xFFFF,0 		;I}[N 




;PCM DATA
	.include "SndData.inc"



;==========================
;HI SCORE
;==========================
;.ORG 0x10800
;HI_SCR: 
;	.word	0x0000
;	.word	0x0000
;	.word	0x0000
;	.word	0x0000
;	.word	0x0000
;	.word	0x0000
;	.word	0x0000
;	.word	0x0000
;=============================================
;END
;=============================================
.end