//=======================================
// EGP01_GW_MH.c
// G&W_Manhole
//=======================================
// Rev 00 : 2012.10.25 Konya (New Release)
//=======================================
#include "p33FJ128GP804.h"
#include "EGP01_Asm.h"

//---------------------------------------------
//֐錾
//---------------------------------------------
//[U[֐ǉꍇ͒ǋL
	void BkDraw(void);														//wi`
	void FwDraw(int MHMAN_ST, int WKUP_ST, int WKDN_ST, int WKFALL_ST);		//Oi`
	void ChrDraw(int x, int y, int to, int chrno, int drwflg);				//L\(/O[I\)
	void ScDraw(int px, int py, int keta);									//_\
	void SndMHMiss(void);
	void SndMHWalk1(void);
	void SndMHWalk2(void);
	void SndMHCatch(void);
	void SndFMClr(void);

//O[oϐ`
extern int 				miss;	//~X
extern int				sc;		//XRA
extern int				gm;		//Game Mode 1=h[Q[@0=PƃQ[	
extern int				gm1_lv;		//x(h[Ŏgp)
extern int				gm1_clrnum; //NA܂ł̐(h[Ŏgp)

extern unsigned char   	GW_CMN0_tp; //Lf[^ uSQ[00v̊i[tblpageAhX̊i[p
extern int             	GW_CMN0_to; //@@@@@@@@@@@@@@@@@@@@@@@@tbloffsetAhX̊i[p

extern unsigned char   	MH_WK_tp;   //Lf[^ u}z[@lv̊i[tblpageAhX̊i[p
extern int             	MH_WK_to;   //@@@@@@@@@@@@@@@@@@@@@@@@tbloffsetAhX̊i[p
extern unsigned char   	MH_MH_tp;   //Lf[^ u}z[@}z[}v̊i[tblpageAhX̊i[p
extern int             	MH_MH_to;   //@@@@@@@@@@@@@@@@@@@@@@@@
extern unsigned char   	MH_BG_tp;   //Lf[^ u}z[@wiv̊i[tblpageAhX̊i[p
extern int             	MH_BG_to;   //@@@@@@@@@@@@@@@@@@@@@@@


//---------------------------------------------
//C
//---------------------------------------------
void GW_MH(void) 
{

//ϐ`Eݒ

	int		MHMAN_ST;
	int		WKUP_ST;
	int		WKDN_ST;
	int		WKFALL_ST;

	int		WK_MAXNUM;
	int		MVCNT,WKUPCNT,WKDNCNT,WK_CNT,LOOPCNT,FALLFLG,FALLCNT;

	int		ENDFLG;
	int		WAIT_TIME;
	int		BTN_ST;
//	int		i,j;



//==========================================================================
//C
//==========================================================================
//---------------------------------------------
//ݒ
//---------------------------------------------
	MHMAN_ST  =1;
	WKUP_ST   =0;
	WKDN_ST   =0;
	WKFALL_ST =0;
	WK_MAXNUM =0;

	MVCNT   =0;
	WKUPCNT =0;
	WKDNCNT =0;
	WK_CNT  =0;
	FALLFLG =0;
	FALLCNT =0;
	LOOPCNT =0;
	ENDFLG  =0;
	WAIT_TIME = 6000;	
	gm1_clrnum =5*gm1_lv;

	//Q[[vp^C}ݒ
	//1[v̎Ԃɂ邽߁A^C}[ŃEFCgԂ𒲐
	T4CONbits.TCKPS = 3;
	PR4 = 0xFFFF;
	T4CONbits.TON = 1;
//---------------------------------------------
//C[v
//---------------------------------------------
	while(ENDFLG ==0)
	{

	//---------------------------------------------
	//}z[}ړ & ʍsl`FbN
	//---------------------------------------------
	//{^͔
	// {^
		if(SLU == 0)		
		{
			MHMAN_ST = 0x01;
		}
	// {^
		else if(SLD == 0)		
		{
			MHMAN_ST = 0x04;
		}

	// E{^
		else if(SRU == 0)		
		{
			MHMAN_ST = 0x02;
		}
	// E{^
		else if(SRD == 0)		
		{
			MHMAN_ST = 0x08;
		}
	//ʍslʂ`FbN
		if(MHMAN_ST == 0x01 && (FALLFLG&0x1)!=0)
		{
			FALLFLG = FALLFLG & 0xE;
			sc++;
			SndMHCatch();	
		}
		else if(MHMAN_ST == 0x02 && (FALLFLG&0x2)!=0)
		{
			FALLFLG = FALLFLG & 0xD;
			sc++;
			SndMHCatch();	
		}
		else if(MHMAN_ST == 0x04 && (FALLFLG&0x4)!=0)
		{
			FALLFLG = FALLFLG & 0xB;
			sc++;
			SndMHCatch();	
		}
		else if(MHMAN_ST == 0x08 && (FALLFLG&0x8)!=0)
		{
			FALLFLG = FALLFLG & 0x7;
			sc++;
			SndMHCatch();	
		}

	//---------------------------------------------
	//ʍslړ
	//---------------------------------------------
	//i
	  if(WKFALL_ST ==0)
	  {
		if(gm==1 && gm1_clrnum==0)
		{
			ENDFLG=1;
			SndFMClr();
		}
					
		if(MVCNT ==8)
		{
			//ʍsl`FbN
			//
			if((FALLFLG&0x1)!=0)
			{
				WKFALL_ST =1;
				WKUP_ST =WKUP_ST & 0x1FB;
				FALLFLG =0;
				FALLCNT =0;
				miss++;
				if(miss ==3){ENDFLG=1;}
				SndMHMiss();
			}
			//E
			else if((FALLFLG&0x2)!=0)
			{
				WKFALL_ST =2;
				WKUP_ST =WKUP_ST & 0x1DF;
				FALLFLG =0;
				FALLCNT =0;
				miss++;
				if(miss ==3){ENDFLG=1;}
				SndMHMiss();
			}
			else
			{
				WKUP_ST =WKUP_ST <<1;			//ʍslړ
				WKUPCNT ++;

				//Vʍslo`FbN
				if(WK_CNT < WK_MAXNUM && (WKUPCNT&0x1)==0 )
				{
					WKUP_ST =WKUP_ST | 0x01;
					WK_CNT++;
				}

				//ʒ[ɏʍsl`FbN
				if((WKUP_ST&0x0100) !=0)
				{
					WK_CNT--;
					if(gm==1)
					{
						gm1_clrnum--;
					}

				}
			
				//ʉ
				if((WKUP_ST&0x1FF) !=0)
				{
				SndMHWalk1();
				}

				//}z[`FbN
				//
				if((WKUP_ST&0x04)!=0)
				{
					FALLFLG = FALLFLG | 0x1;
				}
				//E
				if((WKUP_ST&0x20)!=0)
				{
					FALLFLG = FALLFLG | 0x2;
				}

			}
		}

	//i

		if(MVCNT ==0)
		{
			//ʍsl`FbN
			//E
			if((FALLFLG&0x8)!=0)
			{
				WKFALL_ST =8;
				WKDN_ST =WKDN_ST & 0x1FB;
				FALLFLG =0;
				FALLCNT =0;	
				miss++;
				if(miss ==3){ENDFLG=1;}
				SndMHMiss();
			}
			//
			else if((FALLFLG&0x4)!=0)
			{
				WKFALL_ST =4;
				WKDN_ST =WKDN_ST & 0x1DF;
				FALLFLG =0;
				FALLCNT =0;
				miss++;
				if(miss ==3){ENDFLG=1;}
				SndMHMiss();
			}
			else
			{
				WKDN_ST =WKDN_ST <<1;			//ʍslړ
				WKDNCNT ++;

				//Vʍslo`FbN
				if(WK_CNT < WK_MAXNUM && (WKDNCNT&0x1)==0 )
				{
					WKDN_ST =WKDN_ST | 0x01;
					WK_CNT++;
				}

				//ʒ[ɏʍsl`FbN
				if((WKDN_ST&0x0100) !=0)
				{
					WK_CNT--;
					if(gm==1)
					{
						gm1_clrnum--;
					}

				}
			
				//ʉ
				if((WKDN_ST&0x1FF) !=0)
				{
					SndMHWalk2();
				}
				//}z[`FbN
				//E
				if((WKDN_ST&0x04)!=0)
				{
					FALLFLG = FALLFLG | 0x8;
				}
				//
				if((WKDN_ST&0x20)!=0)
				{
					FALLFLG = FALLFLG | 0x4;
				}

			}
		}


		if(MVCNT < 16)
		{
			MVCNT++;
		}
		else
		{
			MVCNT =0;
		}
	  }
	  else
	  {
		if(FALLCNT > 100)
		{
			WKFALL_ST =0;
			WK_CNT--;
		}
		else
		{
			FALLCNT++;
		}
	  }
	//---------------------------------------------
	//ʕ\XV
	//---------------------------------------------
	//wi`
		BkDraw();
	//Oi`
		FwDraw(MHMAN_ST, WKUP_ST, WKDN_ST, WKFALL_ST);
  	//PICVRAMtֈꊇ]
	     VR_LCDDraw();

	//---------------------------------------------
	//ՓxύX
	//---------------------------------------------
		if((LOOPCNT&0xFF) ==0 )
		{
			if(WK_MAXNUM < 7)
			{
				WK_MAXNUM++;
				
			}
			else
			{
				if(WAIT_TIME >200)
				{
					WAIT_TIME -=200;
				}
			}
		}

		LOOPCNT++;
	//---------------------------------------------
	//EFCg
	//---------------------------------------------

		while( TMR4 < WAIT_TIME) { }	//EFCg
		TMR4 = 0;						//^C}NA
	}
	//---------------------------------------------
	//Q[I[o[
	//---------------------------------------------
	Wait_ms(2000);
	if(gm==0) {ENDFLG =0;}
	BTN_ST =1;
	while(ENDFLG ==0)
	{
		//{^͔		
		if(SRC==0 && BTN_ST==0) 	//E{^		
		{
			ENDFLG=1;
		}
		else
		{
			BTN_ST=0;
		}
	}
	return ;
} 
//-------------------------------------------------------------------------------------
// Tu[`
//-------------------------------------------------------------------------------------
//----------------
// wi`
//----------------
void BkDraw(void)
{
	//wi`恨PICVRAM
	VR_AllClr(0x0000);

  //ubN
	TBLPAG = MH_BG_tp;
	VR_ChrDraw(  0, 48, MH_BG_to, 0);	
	VR_ChrDraw(  0, 64, MH_BG_to, 4);
	VR_ChrDraw( 16, 48, MH_BG_to, 1);
    VR_ChrDraw( 16, 64, MH_BG_to, 5);
	VR_ChrDraw( 96, 48, MH_BG_to, 2);
	VR_ChrDraw(112, 48, MH_BG_to, 0);
	VR_ChrDraw( 96, 64, MH_BG_to, 6);
	VR_ChrDraw(112, 64, MH_BG_to, 4);
	VR_ChrDraw( 64, 48, MH_BG_to, 5);
	VR_ChrDraw(  0, 96, MH_BG_to, 0);
	VR_ChrDraw(  0,112, MH_BG_to, 5);
	VR_ChrDraw( 16, 96, MH_BG_to, 1);
	VR_ChrDraw( 96, 96, MH_BG_to, 2);
	VR_ChrDraw(112, 96, MH_BG_to, 0);
	VR_ChrDraw(112,112, MH_BG_to, 4);

	VR_ChrDraw( 48, 48, MH_BG_to, 8);
	VR_ChrDraw( 64, 48, MH_BG_to, 9);
	VR_ChrDraw( 48, 64, MH_BG_to,12);
	VR_ChrDraw( 64, 64, MH_BG_to,13);

	VR_ChrDraw( 48, 96, MH_BG_to,10);
	VR_ChrDraw( 64, 96, MH_BG_to,11);
	VR_ChrDraw( 48,112, MH_BG_to,14);
	VR_ChrDraw( 64,112, MH_BG_to,15);

  //
    VR_ChrDraw( 28, 60, MH_BG_to,16);
	VR_ChrDraw( 44, 60, MH_BG_to,17);

    VR_ChrDraw( 76, 60, MH_BG_to,18);
	VR_ChrDraw( 92, 60, MH_BG_to,19);

    VR_ChrDraw( 28,112, MH_BG_to,20);
	VR_ChrDraw( 44,112, MH_BG_to,21);

    VR_ChrDraw( 76,112, MH_BG_to,22);
	VR_ChrDraw( 92,112, MH_BG_to,23);

	return;
}
//----------------
// Oi`
//----------------
void FwDraw(int MHMAN_ST, int WKUP_ST,int  WKDN_ST, int WKFALL_ST)
{
 //Walker
  //i
	TBLPAG = MH_WK_tp;
	ChrDraw(  0, 32, MH_WK_to, 1, WKUP_ST&0x01); //1l
	ChrDraw( 16, 32, MH_WK_to, 2, WKUP_ST&0x02); //    2l
	ChrDraw( 32, 32, MH_WK_to, 3, WKUP_ST&0x04); //    3l
	ChrDraw( 48, 32, MH_WK_to, 1, WKUP_ST&0x08); //    4l	
	ChrDraw( 64, 32, MH_WK_to, 2, WKUP_ST&0x10); //    5l
	ChrDraw( 80, 32, MH_WK_to, 3, WKUP_ST&0x20); //    6l
	ChrDraw( 96, 32, MH_WK_to, 2, WKUP_ST&0x40); //    7l
	ChrDraw(112, 32, MH_WK_to, 0, WKUP_ST&0x80); //    8l
  //i
	TBLPAG = MH_WK_tp;
	ChrDraw(  0, 80, MH_WK_to, 5, WKDN_ST&0x80); //1l
	ChrDraw( 16, 80, MH_WK_to, 6, WKDN_ST&0x40); //    2l
	ChrDraw( 32, 80, MH_WK_to, 7, WKDN_ST&0x20); //    3l
	ChrDraw( 48, 80, MH_WK_to, 5, WKDN_ST&0x10); //    4l	
	ChrDraw( 64, 80, MH_WK_to, 6, WKDN_ST&0x08); //    5l
	ChrDraw( 80, 80, MH_WK_to, 7, WKDN_ST&0x04); //    6l
	ChrDraw( 96, 80, MH_WK_to, 6, WKDN_ST&0x02); //    7l
	ChrDraw(112, 80, MH_WK_to, 4, WKDN_ST&0x01); //    8l
  //
	ChrDraw( 28, 58, MH_WK_to, 8, WKFALL_ST&0x01); //
	ChrDraw( 84, 58, MH_WK_to, 9, WKFALL_ST&0x02); //E
	ChrDraw( 30,110, MH_WK_to,10, WKFALL_ST&0x04); //
	ChrDraw( 82,110, MH_WK_to,11, WKFALL_ST&0x08); //E
  //}z[}
	TBLPAG = MH_MH_tp;
	//
	ChrDraw(32, 48, MH_MH_to, 0, MHMAN_ST&0x1);
	//E
	ChrDraw(64, 48, MH_MH_to, 1, MHMAN_ST&0x2);
	//
	ChrDraw(32, 96, MH_MH_to, 2, MHMAN_ST&0x4);
	//E
	ChrDraw(66, 96, MH_MH_to, 3, MHMAN_ST&0x8);

  //~X
	TBLPAG = GW_CMN0_tp;
	ChrDraw(112,  0, GW_CMN0_to,17, miss>0);
	ChrDraw( 96,  0, GW_CMN0_to,17, miss>1);
	ChrDraw( 80,  0, GW_CMN0_to,17, miss>2);
	VR_ChrDraw( 54,  0, GW_CMN0_to,10);
	VR_ChrDraw( 70,  0, GW_CMN0_to,11);
  //GAME C
	VR_ChrDraw(  0,112, GW_CMN0_to,12);
	VR_ChrDraw( 16,112, GW_CMN0_to,13);
  //_
	if(gm==1)
	{
		ScDraw(0,0,4);
	}
	else
	{
		ScDraw(0,0,3);
	}
	
  //NAJEg,x
	if(gm==1)
	{
		VR_NumDrw(32,20,gm1_clrnum,0x03, 1);
		VR_MojiDraw(102, 20,'L', 0x03, 0);
		VR_MojiDraw(106, 20,'V', 0x03, 0);
		VR_NumDrw(98,20,gm1_lv,0x03, 0);
	}
	return;

}

//----------------
// L\
//----------------
void ChrDraw(int x, int y, int to, int chrno, int drwflg)
{
//drawflg=OȂO[\AOȊOȂ獕\
	if(drwflg ==0 ) 
	{
		VR_ChrDrawC( x, y, to, chrno, 0x0E);
	}
	else
	{
		VR_ChrDrawC( x, y, to, chrno, 0x0F);
	}
	return;
}
//----------------
// MISSʉo
//----------------
void SndMHMiss(void)
{
	asm("MOV	#_Snd0_ST+4,w0");
	asm("MOV	#tblpage(_snd_MH_Miss),w3");		//TEhf[^i[AhX̐ݒ
	asm("MOV	w3, [w0++]");						//tblpageSnd0_ST +4,5ɐݒ
	asm("MOV	#tbloffset(_snd_MH_Miss),w3");		//tbloffsetSnd0_ST +6,7ɐݒ
	asm("MOV	w3, [w0++]");
	SndSet0();
	return;
}
//----------------
// ʉo
//----------------
void SndMHWalk1(void)
{
	asm("MOV	#_Snd0_ST+4,w0");
	asm("MOV	#tblpage(_snd_MH_walk1),w3");		//TEhf[^i[AhX̐ݒ
	asm("MOV	w3, [w0++]");						//tblpageSnd0_ST +4,5ɐݒ
	asm("MOV	#tbloffset(_snd_MH_walk1),w3");		//tbloffsetSnd0_ST +6,7ɐݒ
	asm("MOV	w3, [w0++]");
	SndSet0();
	return;
}
//----------------
// ʉo
//----------------
void SndMHWalk2(void)
{
	asm("MOV	#_Snd0_ST+4,w0");
	asm("MOV	#tblpage(_snd_MH_walk2),w3");		//TEhf[^i[AhX̐ݒ
	asm("MOV	w3, [w0++]");						//tblpageSnd0_ST +4,5ɐݒ
	asm("MOV	#tbloffset(_snd_MH_walk2),w3");		//tbloffsetSnd0_ST +6,7ɐݒ
	asm("MOV	w3, [w0++]");
	SndSet0();
	return;
}
//----------------
// Lb`ʉo
//----------------
void SndMHCatch(void)
{
	asm("MOV	#_Snd0_ST+4,w0");
	asm("MOV	#tblpage(_snd_MH_Catch),w3");		//TEhf[^i[AhX̐ݒ
	asm("MOV	w3, [w0++]");						//tblpageSnd0_ST +4,5ɐݒ
	asm("MOV	#tbloffset(_snd_MH_Catch),w3");		//tbloffsetSnd0_ST +6,7ɐݒ
	asm("MOV	w3, [w0++]");
	SndSet0();
	return;
}